	.dbfile C:\iccv7arm\MICROM~1\MIB601~1\MicroBoltDebuggerExample.c
	AREA	"Cidata", DATA
	EXPORT _TestLedFlag
_TestLedFlag:
	DCB 0
	.dbsym e TestLedFlag _TestLedFlag c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;          Count -> R6
;          Delay -> R7
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 42
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltDebuggerExample.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 4/2/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include <STDIO.h>
; 
; #include "MicroBoltDebuggerExample.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; extern int _textmode;		                        // This is defined in the ICCARM library 
; unsigned char TestLedFlag = LED_BLINK;
; 		
; void main(void)
;   {
	.dbline 51
; 
; /*
; |----------------------------------------------------
; |     MicroBolt hardware setup 
; |----------------------------------------------------
; */
; 
;   unsigned int Delay; 
;   unsigned int Count = 0;
	mov R6,#0
	.dbline 53
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 60
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 61
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 63
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 70
; 
; /*
; |-------------------------
; | Config PLL 
; |-------------------------
; */
;   VICVectAddr8 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+8
	ldr R5,LIT_main+12
	str R4,[R5,#0]
	.dbline 71
;   VICVectCntl8 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 72
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 74
; 
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+24
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 75
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+28
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 76
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 77
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 84
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000000;                       // JTAG is via secondary port
	mov R4,#0
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 85
;   PCB_PINSEL1=0x55400000;
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 87
;  
;   GPIO_IODIR=(0x00000000<<16)|                  // Make all inputs to start with
	mov R4,#0
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 90
; 	     0x00000000;
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+48
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 97
; 
; /*
; |-------------------------
; | Config UART-O 
; |-------------------------
; */
;   PCB_PINSEL0 |= P0_0_UART_0_TX;                // Setup P0.0 to alternate function UART0-TX
	ldr R4,LIT_main+36
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 97
	.dbline 98
;   PCB_PINSEL0 |= P0_1_UART_0_RX;                // Setup P0.1 to alternate function UART0-RX
	ldr R4,LIT_main+36
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 98
	.dbline 100
; 
;   VICVectAddr0 = (unsigned)Uart0_ISR;           // Assign the UART-0 ISR vector address
	ldr R4,LIT_main+52
	ldr R5,LIT_main+56
	str R4,[R5,#0]
	.dbline 101
;   VICVectCntl0 = 0x20 | 6;                      // Assign the VIC address to the actual interrupt
	mov R4,#38
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 102
;   VICIntEnable = 0x00000040;                    // Enable the interrupt  
	mov R4,#64
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 104
; 
;   UART0_IER = 0x00000001;	 	                   // Receive interrupts
	mov R4,#1
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 105
;   UART0_FCR = 0x00000001;	 	                   // Enable the fifos
	mov R4,#1
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 106
;   UART0_LCR = 0x00000083;	 	                   // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 107
;   UART0_DLM = 0;				                       // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 108
;   UART0_DLL = BAUD_RATE_115200;			           // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 109
;   UART0_LCR = 0x00000003;  	                   // Close it, then UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 111
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 120
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                            // Do this forever
;     {
	.dbline 121
;     Count++;                                          // Increment test counter
	add R6,R6,#1
	.dbline 123
;                                                     
;     printf("1The count starts here --> %d\n", Count); // Output string to Debug window 1
	ldr R0,LIT_main+80
	mov R1,R6
	bl _printf
	.dbline 124
;     printf("2%d\n", Count+1);                         // Output string to Debug window 2 
	ldr R0,LIT_main+84
	add R1,R6,#1
	bl _printf
	.dbline 125
;     printf("3%d\n", Count+2);                         // Output string to Debug window 3
	ldr R0,LIT_main+88
	add R1,R6,#2
	bl _printf
	.dbline 126
;     printf("4%d\n", Count+3);                         // Output string to Debug window 4 
	ldr R0,LIT_main+92
	add R1,R6,#3
	bl _printf
	.dbline 127
;     printf("5%d\n", Count+4);                         // Output string to Debug window 5 
	ldr R0,LIT_main+96
	add R1,R6,#4
	bl _printf
	.dbline 128
;     printf("6%d\n", Count+5);                         // Output string to Debug window 6 
	ldr R0,LIT_main+100
	add R1,R6,#5
	bl _printf
	.dbline 129
;     printf("7%d\n", Count+6);                         // Output string to Debug window 7 
	ldr R0,LIT_main+104
	add R1,R6,#6
	bl _printf
	.dbline 130
;     printf("8And finally ends here...%d\n", Count+8); // Output string to Debug window 8
	ldr R0,LIT_main+108
	add R1,R6,#8
	bl _printf
	.dbline 131
;     printf("9Hello World!\n");                        // Output string to Debug window 9 
	ldr R0,LIT_main+112
	bl _printf
	.dbline 133
; 
;     if (TestLedFlag == LED_BLINK)
	ldr R4,LIT_main+116
	ldrb R4,[R4,#0]
	cmp R4,#0
	bne L14
	.dbline 134
;       {
	.dbline 135
;       GPIO_IOSET = MICROBOLT_LED;                       // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+120
	str R4,[R5,#0]
	.dbline 136
	mov R7,#0
	b L19
L16:
	.dbline 136
L17:
	.dbline 136
	add R7,R7,#1
L19:
	.dbline 136
;       for (Delay = 0; Delay < 600000; Delay++);         // Delay
	ldr R4,LIT_main+124
	cmp R7,R4
	blo L16
	.dbline 137
;       printf("L1\n");
	ldr R0,LIT_main+128
	bl _printf
	.dbline 138
;       GPIO_IOCLR = MICROBOLT_LED;                       // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+132
	str R4,[R5,#0]
	.dbline 139
	mov R7,#0
	b L24
L21:
	.dbline 139
L22:
	.dbline 139
	add R7,R7,#1
L24:
	.dbline 139
;       for (Delay = 0; Delay < 600000; Delay++);         // Delay
	ldr R4,LIT_main+124
	cmp R7,R4
	blo L21
	.dbline 140
;       printf("L0\n");
	ldr R0,LIT_main+136
	bl _printf
	.dbline 141
;       }
	b L15
L14:
	.dbline 143
;     else
;     if (TestLedFlag == LED_ON)
	ldr R4,LIT_main+116
	ldrb R4,[R4,#0]
	cmp R4,#1
	bne L26
	.dbline 144
;       {
	.dbline 145
;       GPIO_IOSET = MICROBOLT_LED;                       // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+120
	str R4,[R5,#0]
	.dbline 146
	mov R7,#0
	b L31
L28:
	.dbline 146
L29:
	.dbline 146
	add R7,R7,#1
L31:
	.dbline 146
;       for (Delay = 0; Delay < 600000; Delay++);         // Delay
	ldr R4,LIT_main+124
	cmp R7,R4
	blo L28
	.dbline 147
;       printf("L1\n");
	ldr R0,LIT_main+128
	bl _printf
	.dbline 148
;       }
	b L27
L26:
	.dbline 150
;     else
;     if (TestLedFlag == LED_OFF)
	ldr R4,LIT_main+116
	ldrb R4,[R4,#0]
	cmp R4,#2
	bne L32
	.dbline 151
;       {
	.dbline 152
;       GPIO_IOCLR = MICROBOLT_LED;                       // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+132
	str R4,[R5,#0]
	.dbline 153
	mov R7,#0
	b L37
L34:
	.dbline 153
L35:
	.dbline 153
	add R7,R7,#1
L37:
	.dbline 153
;       for (Delay = 0; Delay < 600000; Delay++);         // Delay
	ldr R4,LIT_main+124
	cmp R7,R4
	blo L34
	.dbline 154
;       printf("L0\n");
	ldr R0,LIT_main+136
	bl _printf
	.dbline 155
;       }              
L32:
L27:
L15:
	.dbline 156
L3:
	.dbline 119
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD _pll_isr
	DCD -3808
	DCD -3552
	DCD -4080
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD _Uart0_ISR
	DCD -3840
	DCD -3584
	DCD -536821756
	DCD -536821752
	DCD -536821748
	DCD -536821760
	DCD L5
	DCD L6
	DCD L7
	DCD L8
	DCD L9
	DCD L10
	DCD L11
	DCD L12
	DCD L13
	DCD _TestLedFlag
	DCD -536707068
	DCD 600000
	DCD L20
	DCD -536707060
	DCD L25
	.dbsym r Count 6 i
	.dbsym r Delay 7 i
	.dbend
	EXPORT _putchar
	.dbfunc e putchar _putchar fI
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     SerialByte -> R6
_putchar:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 170
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   putchar
; |     Inputs          :   Byte for transmission
; |     Outputs         :   None
; |     Purpose         :   Transmit a byte via UART0 to enable printf
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; int putchar(char SerialByte)
;   {
	.dbline 171
;   _textmode = 1;                                      // Turn carriage return line feed on for printf
	mov R4,#1
	ldr R5,LIT_putchar+0
	str R4,[R5,#0]
	.dbline 172
;   if (_textmode == 1 && SerialByte == '\n')
	ldr R4,LIT_putchar+0
	ldr R4,[R4,#0]
	cmp R4,#1
	bne L42
	and R4,R6,#255
	cmp R4,#10
	bne L42
	.dbline 173
;       {
	.dbline 174
;       putchar('\r');
	mov R0,#13
	bl _putchar
	.dbline 175
;       }
L41:
	.dbline 176
L42:
	.dbline 176
;   while (!(UART0_LSR & 0x20)); 
	ldr R4,LIT_putchar+4
	ldr R4,[R4,#0]
	tst R4,#32
	beq L41
	.dbline 177
;   UART0_THR = SerialByte;
	and R4,R6,#255
	ldr R5,LIT_putchar+8
	str R4,[R5,#0]
	.dbline 178
;   return SerialByte;
	and R0,R6,#255
	.dbline -2
L38:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
LIT_putchar:
	DCD __textmode
	DCD -536821740
	DCD -536821760
	.dbsym r SerialByte 6 c
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 194
;   }
; 
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; void pll_isr(void)
;   {
	.dbline 195
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 196
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 197
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 198
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 199
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L44:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"Cidata", DATA
L46:
	DCB 0
	AREA	"Cudata", NOINIT
L47:
	SPACE 20
L48:
	SPACE 1
	AREA	"C$$code", CODE, READONLY
	EXPORT _Uart0_ISR
	.dbfunc e Uart0_ISR _Uart0_ISR fV
	.dbsym s LedFlip L48 c
	.dbsym s SerialBuffer L47 A[20:20]c
	.dbsym s CharRxCount L46 c
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_Uart0_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R4,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 215
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Uart0_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Interrut service routine for Uart-0
; |     Author          :   Pride Embedded, LLC
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler Uart0_ISR
; 
; void Uart0_ISR (void)   
;   {
	.dbline 220
;   static unsigned char CharRxCount = 0;
;   static unsigned char SerialBuffer[20];   
;   static unsigned char LedFlip; 
;   
;   switch(UART0_IIR & 0x0F)
	ldr R0,LIT_Uart0_ISR+0
	ldr R0,[R0,#0]
	and R4,R0,#15
	mov R0,R4
	cmp R0,#4
	beq L52
	b L50
X1:
	.dbline 221
;       {
L52:
	.dbline 229
;       case 0x04:                                                  // Receive data available
; 
; /*
; |----------------------------------------------------
; |     Get serial port data and check for commands
; |----------------------------------------------------
; */            
;       SerialBuffer[CharRxCount] = UART0_RBR;
	ldr R0,LIT_Uart0_ISR+4
	ldrb R0,[R0,#0]
	ldr R1,LIT_Uart0_ISR+8
	ldr R2,LIT_Uart0_ISR+12
	ldr R2,[R2,#0]
	strb R2,[R0,+R1]
	.dbline 231
; 
;       if (SerialBuffer[0] == 'L')
	ldr R0,LIT_Uart0_ISR+8
	ldrb R0,[R0,#0]
	cmp R0,#76
	bne L53
	.dbline 232
;           {
	.dbline 233
;           if (CharRxCount == 2)
	ldr R0,LIT_Uart0_ISR+4
	ldrb R0,[R0,#0]
	cmp R0,#2
	bne L55
	.dbline 234
;               {
	.dbline 235
;               switch(SerialBuffer[1])
	ldr R0,LIT_Uart0_ISR+16
	ldrb R4,[R0,#0]
	cmp R4,#65
	beq L61
	cmp R4,#66
	beq L62
	cmp R4,#67
	beq L63
	b L58
X2:
	.dbline 236
;                   {
L61:
	.dbline 238
;                   case 'A':  
;                       {
	.dbline 239
;                       TestLedFlag = LED_ON;                                                 
	mov R0,#1
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 240
;                       break;
	b L58
L62:
	.dbline 243
;                       }
;                   case 'B':  
;                       {
	.dbline 244
;                       TestLedFlag = LED_BLINK;                                                 
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 245
;                       break;
	b L58
L63:
	.dbline 248
;                       }
;                   case 'C':  
;                       {
	.dbline 249
;                       TestLedFlag = LED_OFF;                                                 
	mov R0,#2
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 250
;                       break;
	.dbline 253
;                       }
;                   default:
;                       {
	.dbline 254
;                       break;
L58:
	.dbline 257
;                       }
;                   }
;               CharRxCount = 0; 
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+4
	strb R0,[R1,#0]
	.dbline 258
;               }
	b L50
L55:
	.dbline 260
;           else
;               {
	.dbline 261
;               CharRxCount++;      
	ldr R0,LIT_Uart0_ISR+4
	ldrb R1,[R0,#0]
	add R1,R1,#1
	strb R1,[R0,#0]
	.dbline 262
;               }          
	.dbline 263
;           }
	b L50
L53:
	.dbline 265
;     else
;           {
	.dbline 266
;           CharRxCount = 0;        
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+4
	strb R0,[R1,#0]
	.dbline 267
;           }          
	.dbline 268
;     break;
	.dbline 271
; 
;     default:
;     break;
L50:
	.dbline 273
;     }
; 	  VICVectAddr = 0;                            // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+24
	str R0,[R1,#0]
	.dbline -2
L45:
	ldmfd R13!,{R0,R1,R2,R4,R11,R12,PC}^
	.dbline 0 ; func end
LIT_Uart0_ISR:
	DCD -536821752
	DCD L46
	DCD L47
	DCD -536821760
	DCD L47+1
	DCD _TestLedFlag
	DCD -4048
	.dbend
	IMPORT __textmode
	AREA	"C$$code", CODE, READONLY
L25:
	DCB "L0", 10, 0
L20:
	DCB "L1", 10, 0
L13:
	DCB "9Hello World!", 10, 0
L12:
	DCB "8And finally ends here...%d", 10, 0
L11:
	DCB "7%d", 10, 0
L10:
	DCB "6%d", 10, 0
L9:
	DCB "5%d", 10, 0
L8:
	DCB "4%d", 10, 0
L7:
	DCB "3%d", 10, 0
L6:
	DCB "2%d", 10, 0
L5:
	DCB "1The count starts here --> %d", 10, 0
	END
