/*
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
| File Name			  : MicroBoltSerialDebugger.h																					
| Author			    : Micromint, Inc.						
| Copyright       : Copyright  2005, Micromint, Inc.																	
| Creation Date		: 9/30/05																							
| Version			    : 1.00																																												
| Spaces per tab	:	2																									
| Description		  : Header file																																									 
| Revision			  :	Initial																																																						
|------------------------------------------------------------------------------------------
|------------------------------------------------------------------------------------------
*/

/*
|----------------------------------------------------
|     Function prototypes
|----------------------------------------------------
*/

void pll_isr(void);  
void Uart0_ISR (void);
void SerialDebug(char DebugBoxNum, char *fmt,...);
void SerialDebugLed(char LedOnOrOff);

/*
|----------------------------------------------------
|     Defines
|----------------------------------------------------
*/ 

#define PCLK_FREQ           					14745600          // Crystal frequency in Hz
#define CCLK_FREQ            					58982400          // Frequency after PLL multiplication

#define MICROBOLT_LED                 0x00400000        // On-board Test LED

#define P0_0_UART_0_TX                0x00000001;       // P0.0 alternate function UART0-TX
#define P0_1_UART_0_RX                0x00000004;       // P0.1 alternate function UART0-RX

#define  INTERRUPT_CHANNEL_FOR_PLL    0x20 | 12         // The VIC channel for PLL
#define  INTERRUPT_ENABLE_FOR_PLL     0x00001000        // The VIC enable for the PLL

#define  INTERRUPT_CHANNEL_FOR_UART0  0x20 | 6;         // The VIC channel for UART0
#define  INTERRUPT_ENABLE_FOR_UART0   0x00000040;       // The VIC enable for the UART0

#define  VIC_ACK                      0x00000000        // VIC acknowledge 
#define  PLL_CLR                      0x00001000        // Clear PLL flag  

#define TRUE                          1
#define FALSE                         0

#define LED_BLINK                     0
#define LED_ON                        1
#define LED_OFF                       2   

/*
|----------------------------------------------------
|     Baud rate definitions
|----------------------------------------------------
*/ 

#define BAUD_RATE_4800      208
#define BAUD_RATE_9600      96
#define BAUD_RATE_19200     48
#define BAUD_RATE_38400     24
#define BAUD_RATE_57600     16
#define BAUD_RATE_115200    8

/*
|----------------------------------------------------
| MAM - Memory Acceleration Module
|----------------------------------------------------
*/	

#define MAM_CR					(*(REG32 (0xE01FC000)))
#define MAM_TIM					(*(REG32 (0xE01FC004)))  