	.dbfile C:\iccv7arm\MID366~1\MicroBoltSerialDebugger.c
	AREA	"Cidata", DATA
	EXPORT _TestLedFlag
_TestLedFlag:
	DCB 0
	.dbsym e TestLedFlag _TestLedFlag c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;         Count2 -> R6
;          Count -> R7
;          Delay -> R8
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 43
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBoltSerialDebugger.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 9/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include <STDIO.h>
; #include <STDARG.h>
; 
; #include "MicroBoltSerialDebugger.h"
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; extern int _textmode;		                        // This is defined in the ICCARM library 
; unsigned char TestLedFlag = LED_BLINK;
; 		
; void main(void)
;   {
	.dbline 46
; 
;   unsigned int Delay; 
;   unsigned int Count = 0;
	mov R7,#0
	.dbline 47
;   unsigned char Count2 = 0;
	mov R6,#0
	.dbline 49
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 56
; 
; /*
; |-------------------------
; | Configure MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 57
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 59
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 66
; 
; /*
; |-------------------------
; | Configure PLL and CCLK
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+8
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 67
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 68
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 69
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 76
; 
; /*
; |-------------------------
; | Configure PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 83
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+24
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 84
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 85
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 87
; 
;   VICVectAddr1 = (unsigned)Uart0_ISR;           // Assign the UART-0 ISR vector address
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 88
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_UART0;   // Assign the VIC address to the actual interrupt
	mov R4,#38
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 88
	.dbline 89
;   VICIntEnable = INTERRUPT_ENABLE_FOR_UART0;    // Enable the interrupt  
	mov R4,#64
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 89
	.dbline 96
; 
; /*
; |-------------------------
; | Configure GPIO 
; |-------------------------
; */
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+52
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 97
;   PCB_PINSEL0 |= P0_0_UART_0_TX;                // Setup P0.0 to alternate function UART0-TX
	ldr R4,LIT_main+56
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 97
	.dbline 98
;   PCB_PINSEL0 |= P0_1_UART_0_RX;                // Setup P0.1 to alternate function UART0-RX
	ldr R4,LIT_main+56
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 98
	.dbline 99
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 106
; 
; /*
; |-------------------------
; | Configure UART-O 
; |-------------------------
; */
;   UART0_IER = 0x00000001;	 	                   // Receive interrupts
	mov R4,#1
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 107
;   UART0_FCR = 0x00000001;	 	                   // Enable the fifos
	mov R4,#1
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 108
;   UART0_LCR = 0x00000083;	 	                   // Enable the divisor
	mov R4,#131
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 109
;   UART0_DLM = 0;				                       // Divisor latch MSB (for baud rates < 4800) 
	mov R4,#0
	ldr R5,LIT_main+64
	str R4,[R5,#0]
	.dbline 110
;   UART0_DLL = BAUD_RATE_115200;			           // Divisor latch LSB 
	mov R4,#8
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 111
;   UART0_LCR = 0x00000003;  	                   // Close it, then UART works with divisor
	mov R4,#3
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 113
; 
;   __ENABLE_INTERRUPT();                        // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	b L3
L2:
	.dbline 122
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                                // Do this forever
;     {
	.dbline 123
;     Count++;                                              // Increment test counter
	add R7,R7,#1
	.dbline 125
;                                                   
;     SerialDebug(1,"The count starts here --> %d", Count); // Output string to Debug window 1
	mov R0,#1
	ldr R1,LIT_main+80
	mov R2,R7
	bl _SerialDebug
	.dbline 126
;     SerialDebug(2,"%d", Count+1);                         // Output string to Debug window 2 
	mov R0,#2
	ldr R1,LIT_main+84
	add R2,R7,#1
	bl _SerialDebug
	.dbline 127
;     SerialDebug(3,"%d", Count+2);                         // Output string to Debug window 3
	mov R0,#3
	ldr R1,LIT_main+84
	add R2,R7,#2
	bl _SerialDebug
	.dbline 128
;     SerialDebug(4,"%d", Count+3);                         // Output string to Debug window 4 
	mov R0,#4
	ldr R1,LIT_main+84
	add R2,R7,#3
	bl _SerialDebug
	.dbline 129
;     SerialDebug(5,"%d", Count+4);                         // Output string to Debug window 5 
	mov R0,#5
	ldr R1,LIT_main+84
	add R2,R7,#4
	bl _SerialDebug
	.dbline 130
;     SerialDebug(6,"%d", Count+5);                         // Output string to Debug window 6 
	mov R0,#6
	ldr R1,LIT_main+84
	add R2,R7,#5
	bl _SerialDebug
	.dbline 131
;     SerialDebug(7,"%d", Count+6);                         // Output string to Debug window 7 
	mov R0,#7
	ldr R1,LIT_main+84
	add R2,R7,#6
	bl _SerialDebug
	.dbline 132
;     SerialDebug(8,"And finally ends here...%d", Count+7); // Output string to Debug window 8
	mov R0,#8
	ldr R1,LIT_main+88
	add R2,R7,#7
	bl _SerialDebug
	.dbline 133
;     SerialDebug(9,"Hello World from MicroBolt!!!");       // Output string to Debug window 9 
	mov R0,#9
	ldr R1,LIT_main+92
	bl _SerialDebug
	.dbline 135
	mov R8,#0
	b L12
L9:
	.dbline 135
L10:
	.dbline 135
	add R8,R8,#1
L12:
	.dbline 135
;        
;     for (Delay = 0; Delay < 370000; Delay++);             // Delay for a few
	ldr R4,LIT_main+96
	cmp R8,R4
	blo L9
	.dbline 142
; 
; /*
; |-------------------------
; | LED control 
; |-------------------------
; */
;     if (TestLedFlag == LED_BLINK)
	ldr R4,LIT_main+100
	ldrb R4,[R4,#0]
	cmp R4,#0
	bne L13
	.dbline 143
;       {
	.dbline 144
;       Count2++;                                         // Now simply blink the serial debugger LED
	and R4,R6,#255
	add R4,R4,#1
	mov R6,R4
	.dbline 145
;       if (Count2 == 10)
	and R4,R6,#255
	cmp R4,#10
	bne L15
	.dbline 146
;         {
	.dbline 147
;         GPIO_IOSET = MICROBOLT_LED; 
	mov R4,#4194304
	ldr R5,LIT_main+104
	str R4,[R5,#0]
	.dbline 148
;         SerialDebugLed(LED_ON);
	mov R0,#1
	bl _SerialDebugLed
	.dbline 149
;         }
	b L14
L15:
	.dbline 151
;       else
;       if (Count2 == 20)
	and R4,R6,#255
	cmp R4,#20
	bne L14
	.dbline 152
;         {
	.dbline 153
;         Count2 = 0;
	mov R6,#0
	.dbline 154
;         GPIO_IOCLR = MICROBOLT_LED; 
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 155
;         SerialDebugLed(LED_OFF);
	mov R0,#2
	bl _SerialDebugLed
	.dbline 156
;         }
	.dbline 157
;       }
	b L14
L13:
	.dbline 159
;     else
;     if (TestLedFlag == LED_ON)
	ldr R4,LIT_main+100
	ldrb R4,[R4,#0]
	cmp R4,#1
	bne L19
	.dbline 160
;       {
	.dbline 161
;       GPIO_IOSET = MICROBOLT_LED;                       // MicroBolt LED On
	mov R4,#4194304
	ldr R5,LIT_main+104
	str R4,[R5,#0]
	.dbline 162
;       SerialDebugLed(LED_ON);
	mov R0,#1
	bl _SerialDebugLed
	.dbline 163
;       }
	b L20
L19:
	.dbline 165
;     else
;     if (TestLedFlag == LED_OFF)
	ldr R4,LIT_main+100
	ldrb R4,[R4,#0]
	cmp R4,#2
	bne L21
	.dbline 166
;       {
	.dbline 167
;       GPIO_IOCLR = MICROBOLT_LED;                       // MicroBolt LED Off
	mov R4,#4194304
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 168
;       SerialDebugLed(LED_OFF);
	mov R0,#2
	bl _SerialDebugLed
	.dbline 169
;       }  
L21:
L20:
L14:
	.dbline 170
L3:
	.dbline 121
	b L2
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _Uart0_ISR
	DCD -3836
	DCD -3580
	DCD -536707064
	DCD -536690688
	DCD -536707060
	DCD -536821756
	DCD -536821752
	DCD -536821748
	DCD -536821760
	DCD L5
	DCD L6
	DCD L7
	DCD L8
	DCD 370000
	DCD _TestLedFlag
	DCD -536707068
	.dbsym r Count2 6 c
	.dbsym r Count 7 i
	.dbsym r Delay 8 i
	.dbend
	EXPORT _SerialDebug
	.dbfunc e SerialDebug _SerialDebug fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;             va -> R4
;            fmt -> R11,20
;    DebugBoxNum -> R11,16
_SerialDebug:
	mov R12,R13
	stmfd R13!,{R0-R3}
	stmfd R13!,{R4,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 184
;     }
; }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   SerialDebug
; |     Inputs          :   Printf for serial debugger
; |     Outputs         :   None
; |     Purpose         :   Transmit data to the MicroBolt Serial Debugger
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void SerialDebug(char DebugBoxNum, char *fmt,...)
;     {
	.dbline 186
;     va_list va;
;     va_start(va, fmt);          
	add R4,R11,#0x18
	.dbline 187
;     printf("%d", DebugBoxNum);
	ldr R0,LIT_SerialDebug+0
	ldrb R1,[R11,#+16]
	bl _printf
	.dbline 188
;     vprintf(fmt,va);
	ldr R0,[R11,#+20]
	mov R1,R4
	bl _vprintf
	.dbline 189
;     printf("\n");
	ldr R0,LIT_SerialDebug+4
	bl _printf
	.dbline -2
L23:
	ldmfd R11,{R4,R11,SP,PC}
	.dbline 0 ; func end
LIT_SerialDebug:
	DCD L6
	DCD L25
	.dbsym r va 4 pc
	.dbsym l fmt 20 pc
	.dbsym l DebugBoxNum 16 c
	.dbend
	EXPORT _SerialDebugLed
	.dbfunc e SerialDebugLed _SerialDebugLed fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     LedOnOrOff -> R5
_SerialDebugLed:
	mov R12,R13
	stmfd R13!,{R4,R5,R11,R12,R14}
	mov R11,R13
	mov R5,R0
	.dbline -1
	.dbline 203
;     }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   SerialDebugLed
; |     Inputs          :   LED for serial debugger
; |     Outputs         :   None
; |     Purpose         :   Transmit data to the MicroBolt Serial Debugger
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void SerialDebugLed(char LedOnOrOff)
;     {
	.dbline 204
;     if (LedOnOrOff == LED_ON)
	and R4,R5,#255
	cmp R4,#1
	bne L27
	.dbline 205
;       {
	.dbline 206
;       printf("L1\n");
	ldr R0,LIT_SerialDebugLed+0
	bl _printf
	.dbline 207
;       }
	b L28
L27:
	.dbline 209
;     else
;     if (LedOnOrOff == LED_OFF)
	and R4,R5,#255
	cmp R4,#2
	bne L30
	.dbline 210
;       {
	.dbline 211
;       printf("L0\n");
	ldr R0,LIT_SerialDebugLed+4
	bl _printf
	.dbline 212
;       }
L30:
L28:
	.dbline -2
L26:
	ldmfd R11,{R4,R5,R11,SP,PC}
	.dbline 0 ; func end
LIT_SerialDebugLed:
	DCD L29
	DCD L32
	.dbsym r LedOnOrOff 5 c
	.dbend
	EXPORT _putchar
	.dbfunc e putchar _putchar fI
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
;     SerialByte -> R6
_putchar:
	mov R12,R13
	stmfd R13!,{R4,R5,R6,R11,R12,R14}
	mov R11,R13
	mov R6,R0
	.dbline -1
	.dbline 226
;     }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   putchar
; |     Inputs          :   Byte for transmission
; |     Outputs         :   None
; |     Purpose         :   Transmit a byte via UART0 to enable printf
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; int putchar(char SerialByte)
;   {
	.dbline 227
;   _textmode = 1;                                // Turn carriage return line feed on for printf
	mov R4,#1
	ldr R5,LIT_putchar+0
	str R4,[R5,#0]
	.dbline 228
;   if (_textmode == 1 && SerialByte == '\n')
	ldr R4,LIT_putchar+0
	ldr R4,[R4,#0]
	cmp R4,#1
	bne L37
	and R4,R6,#255
	cmp R4,#10
	bne L37
	.dbline 229
;       {
	.dbline 230
;       putchar('\r');
	mov R0,#13
	bl _putchar
	.dbline 231
;       }
L36:
	.dbline 232
L37:
	.dbline 232
;   while (!(UART0_LSR & 0x20)); 
	ldr R4,LIT_putchar+4
	ldr R4,[R4,#0]
	tst R4,#32
	beq L36
	.dbline 233
;   UART0_THR = SerialByte;
	and R4,R6,#255
	ldr R5,LIT_putchar+8
	str R4,[R5,#0]
	.dbline 234
;   return SerialByte;
	and R0,R6,#255
	.dbline -2
L33:
	ldmfd R11,{R4,R5,R6,R11,SP,PC}
	.dbline 0 ; func end
LIT_putchar:
	DCD __textmode
	DCD -536821740
	DCD -536821760
	.dbsym r SerialByte 6 c
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 249
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; void pll_isr(void)
;   {
	.dbline 250
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 251
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 252
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 253
;   VICIntEnClear = PLL_CLR;                      // Disable the PLL interrupt, not needed anymore
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 254
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L39:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"Cidata", DATA
L41:
	DCB 0
	AREA	"Cudata", NOINIT
L42:
	SPACE 20
	AREA	"C$$code", CODE, READONLY
	EXPORT _Uart0_ISR
	.dbfunc e Uart0_ISR _Uart0_ISR fV
	.dbsym s SerialBuffer L42 A[20:20]c
	.dbsym s CharRxCount L41 c
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_Uart0_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R4,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 270
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   Uart0_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Interrupt service routine for Uart-0
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler Uart0_ISR
; 
; void Uart0_ISR (void)   
;   {
	.dbline 274
;   static unsigned char CharRxCount = 0;
;   static unsigned char SerialBuffer[20];   
;   
;   switch(UART0_IIR & 0x0F)
	ldr R0,LIT_Uart0_ISR+0
	ldr R0,[R0,#0]
	and R4,R0,#15
	mov R0,R4
	cmp R0,#4
	beq L46
	b L44
X1:
	.dbline 275
;       {
L46:
	.dbline 283
;       case 0x04:                                        // Receive data available
; 
; /*
; |----------------------------------------------------
; |     Get serial port data and check for commands
; |----------------------------------------------------
; */            
;       SerialBuffer[CharRxCount] = UART0_RBR;
	ldr R0,LIT_Uart0_ISR+4
	ldrb R0,[R0,#0]
	ldr R1,LIT_Uart0_ISR+8
	ldr R2,LIT_Uart0_ISR+12
	ldr R2,[R2,#0]
	strb R2,[R0,+R1]
	.dbline 285
; 
;       if (SerialBuffer[0] == 'L')
	ldr R0,LIT_Uart0_ISR+8
	ldrb R0,[R0,#0]
	cmp R0,#76
	bne L47
	.dbline 286
;           {
	.dbline 287
;           if (CharRxCount == 2)
	ldr R0,LIT_Uart0_ISR+4
	ldrb R0,[R0,#0]
	cmp R0,#2
	bne L49
	.dbline 288
;               {
	.dbline 289
;               switch(SerialBuffer[1])
	ldr R0,LIT_Uart0_ISR+16
	ldrb R4,[R0,#0]
	cmp R4,#65
	beq L55
	cmp R4,#66
	beq L56
	cmp R4,#67
	beq L57
	b L52
X2:
	.dbline 290
;                   {
L55:
	.dbline 292
;                   case 'A':  
;                       {
	.dbline 293
;                       TestLedFlag = LED_ON;                                                 
	mov R0,#1
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 294
;                       break;
	b L52
L56:
	.dbline 297
;                       }
;                   case 'B':  
;                       {
	.dbline 298
;                       TestLedFlag = LED_BLINK;                                                 
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 299
;                       break;
	b L52
L57:
	.dbline 302
;                       }
;                   case 'C':  
;                       {
	.dbline 303
;                       TestLedFlag = LED_OFF;                                                 
	mov R0,#2
	ldr R1,LIT_Uart0_ISR+20
	strb R0,[R1,#0]
	.dbline 304
;                       break;
	.dbline 307
;                       }
;                   default:
;                       {
	.dbline 308
;                       break;
L52:
	.dbline 311
;                       }
;                   }
;               CharRxCount = 0; 
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+4
	strb R0,[R1,#0]
	.dbline 312
;               }
	b L44
L49:
	.dbline 314
;           else
;               {
	.dbline 315
;               CharRxCount++;      
	ldr R0,LIT_Uart0_ISR+4
	ldrb R1,[R0,#0]
	add R1,R1,#1
	strb R1,[R0,#0]
	.dbline 316
;               }          
	.dbline 317
;           }
	b L44
L47:
	.dbline 319
;     else
;           {
	.dbline 320
;           CharRxCount = 0;        
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+4
	strb R0,[R1,#0]
	.dbline 321
;           }          
	.dbline 322
;     break;
	.dbline 325
; 
;     default:
;     break;
L44:
	.dbline 327
;     }
; 	  VICVectAddr = VIC_ACK;                            // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_Uart0_ISR+24
	str R0,[R1,#0]
	.dbline -2
L40:
	ldmfd R13!,{R0,R1,R2,R4,R11,R12,PC}^
	.dbline 0 ; func end
LIT_Uart0_ISR:
	DCD -536821752
	DCD L41
	DCD L42
	DCD -536821760
	DCD L42+1
	DCD _TestLedFlag
	DCD -4048
	.dbend
	IMPORT __textmode
	AREA	"C$$code", CODE, READONLY
L32:
	DCB "L0", 10, 0
L29:
	DCB "L1", 10, 0
L25:
	DCB 10, 0
L8:
	DCB "Hello World from MicroBolt!!!", 0
L7:
	DCB "And finally ends here...%d", 0
L6:
	DCB "%d", 0
L5:
	DCB "The count starts here --> %d", 0
	END
